package com.perfectech.tis.activities;

import android.content.ContentValues;
import android.content.Context;
import android.content.ContextWrapper;
import android.content.Intent;
import android.content.SharedPreferences;
import android.graphics.Bitmap;
import android.graphics.Canvas;
import android.graphics.Color;
import android.graphics.Paint;
import android.graphics.Path;
import android.graphics.RectF;
import android.os.Environment;
import android.provider.MediaStore;
import android.os.Bundle;
import android.support.v7.app.AppCompatActivity;
import android.util.AttributeSet;
import android.util.Log;
import android.view.Gravity;
import android.view.Menu;
import android.view.MenuItem;
import android.view.MotionEvent;
import android.view.View;
import android.view.ViewGroup;
import android.view.inputmethod.InputMethodManager;
import android.widget.EditText;
import android.widget.LinearLayout;
import android.widget.Toast;

import com.perfectech.tis.DateConvertClass;
import com.perfectech.tis.R;
import com.perfectech.tis.syncClasses.SyncIntentService;
import com.perfectech.tis.syncClasses.SyncTasks;
import com.perfectech.tis.TISDBHelper;

import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Calendar;


public class SigCapture extends AppCompatActivity {

    private static final String sDBName = "TIS.db";
    private static final int iVersionVal = 6;
    private static String sUserID = "";
    private static ArrayList<ArrayList<String>> userArray;
    private static String sInType = "";
    private static String sInJobNum = "";
    private Bitmap mBitmap;
    private EditText yourName;
    private MenuItem miSave;
    private MenuItem miErase;
    LinearLayout mContent;
    View mView;
    signature mSignature;
    private String sPrivateDir = "signatures";
    private String current = null; //This is the current signature name

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_sig_capture);

        SharedPreferences prefs = getSharedPreferences("TISSharedPrefs",
                Context.MODE_PRIVATE);
        SharedPreferences.Editor editor = prefs.edit();
        String sLoggedInUserCompany = prefs.getString("LoggedInUserCompany", "No Value");
        sUserID = prefs.getString("UserID","No Value");

        sInType = getIntent().getExtras().getString("InType");
        sInJobNum = getIntent().getExtras().getString("InJobNum");

        yourName = (EditText) findViewById(R.id.yourName);

        if (sInType.equals("USER")) {
            current = "sig_" + sUserID + ".png";
        } else {
            current = "sig_" +sInType + "_" + sInJobNum + ".png";
        }

        mContent = (LinearLayout) findViewById(R.id.linearLayout);
        mSignature = new signature(this, null);
        mSignature.setBackgroundColor(Color.WHITE);
        mContent.addView(mSignature, ViewGroup.LayoutParams.FILL_PARENT, ViewGroup.LayoutParams.FILL_PARENT);
        mView = mContent;

    }

    public void onResume() {
        super.onResume();

        if (sInType.equals("USER")) {
            EditText etYourName = (EditText) findViewById(R.id.yourName);
            etYourName.setText(getUserFullName());
        }
    }
        @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        // Inflate the menu; this adds items to the action bar if it is present.
        getMenuInflater().inflate(R.menu.menu_sig_capture, menu);
            miSave = menu.findItem(R.id.action_save);
            miErase = menu.findItem(R.id.action_clear);
        return true;
    }

    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        // Handle action bar item clicks here. The action bar will
        // automatically handle clicks on the Home/Up button, so long
        // as you specify a parent activity in AndroidManifest.xml.
        int id = item.getItemId();

        //noinspection SimplifiableIfStatement
        if (id == R.id.action_save) {
            Log.v("log_tag", "Panel Saved");
            boolean error = captureSignature();
            if(!error){
                mView.setDrawingCacheEnabled(true);
                mSignature.save(mView);
                Bundle b = new Bundle();
                b.putString("status", "done");
                InputMethodManager imm = (InputMethodManager)getSystemService(Context.INPUT_METHOD_SERVICE);
                imm.hideSoftInputFromWindow(yourName.getWindowToken(), 0);
                Intent intent = new Intent();
                intent.putExtras(b);
                setResult(RESULT_OK,intent);
                finish();
            }
            return true;
        }
        if (id == R.id.action_cancel) {
            Log.v("log_tag", "Panel Canceled");
            Bundle b = new Bundle();
            b.putString("status", "cancel");
            InputMethodManager imm = (InputMethodManager)getSystemService(Context.INPUT_METHOD_SERVICE);
            imm.hideSoftInputFromWindow(yourName.getWindowToken(), 0);
            Intent intent = new Intent();
            intent.putExtras(b);
            setResult(RESULT_OK, intent);
            finish();
            return true;
        }
        if (id == R.id.action_clear) {
            Log.v("log_tag", "Panel Cleared");
            mSignature.clear();
            miSave.setVisible(false);
            miErase.setVisible(false);
            InputMethodManager imm = (InputMethodManager)getSystemService(Context.INPUT_METHOD_SERVICE);
            imm.hideSoftInputFromWindow(yourName.getWindowToken(), 0);
            return true;
        }
        if (id == R.id.action_icon_meanings) {
            Intent i = new Intent(getApplicationContext(), HelpActivity.class);
            i.putExtra("ScreenID", "IconMeanings");
            startActivity(i);
            return true;
        }
        if (id == R.id.action_help) {
            Intent i = new Intent(getApplicationContext(), HelpActivity.class);
            i.putExtra("ScreenID","SigCapture");
            startActivity(i);
            return true;
        }
        if (id == R.id.action_about) {
            Intent i = new Intent(getApplicationContext(), AboutActivity.class);
            startActivity(i);
            return true;
        }

        return super.onOptionsItemSelected(item);
    }

    private String getUserFullName() {
        String sRtnVal = "";

        TISDBHelper oDB = new TISDBHelper(getApplicationContext(), sDBName,
                null, iVersionVal);
        try {
            oDB.createDataBase();
        } catch (IOException ioe) {
            throw new Error("Unable to create database");
        }

        oDB.openDataBase();
        String sSQL = "Select FirstName ||' '|| LastName ";
        sSQL += "from EmployeeMaster ";
        sSQL += " where UserID = '" + sUserID + "'";

        Log.d("sSQL", sSQL);

        userArray = oDB.selectRecordsFromDBList(sSQL, null);

        // closes the database
        try {
            oDB.close();
        } catch (Throwable e) {
            e.printStackTrace();
        }

        if (userArray.size() > 0) {
            for (ArrayList<String> sValue : userArray) {
                sRtnVal = sValue.get(0);
            }
        }

        return sRtnVal;
    }

    private boolean captureSignature() {

        boolean error = false;
        String errorMessage = "";


        if(yourName.getText().toString().equalsIgnoreCase("")){
            errorMessage = errorMessage + "Please enter your Name\n";
            error = true;
        }

        if(error){
            Toast toast = Toast.makeText(this, errorMessage, Toast.LENGTH_SHORT);
            toast.setGravity(Gravity.TOP, 105, 50);
            toast.show();
        }

        return error;
    }

    public class signature extends View
    {
        private static final float STROKE_WIDTH = 5f;
        private static final float HALF_STROKE_WIDTH = STROKE_WIDTH / 2;
        private Paint paint = new Paint();
        private Path path = new Path();

        private float lastTouchX;
        private float lastTouchY;
        private final RectF dirtyRect = new RectF();

        public signature(Context context, AttributeSet attrs)
        {
            super(context, attrs);
            paint.setAntiAlias(true);
            paint.setColor(Color.BLACK);
            paint.setStyle(Paint.Style.STROKE);
            paint.setStrokeJoin(Paint.Join.ROUND);
            paint.setStrokeWidth(STROKE_WIDTH);
        }

        public void save(View v)
        {
            Log.v("log_tag", "Width: " + v.getWidth());
            Log.v("log_tag", "Height: " + v.getHeight());
            if(mBitmap == null)
            {
                mBitmap =  Bitmap.createBitmap(mContent.getWidth(), mContent.getHeight(), Bitmap.Config.RGB_565);;
            }
            Canvas canvas = new Canvas(mBitmap);
            try
            {
                File myDir = getDir(sPrivateDir, Context.MODE_PRIVATE);
                File fileWithinMyDir = new File(myDir, current);
                FileOutputStream mFileOutStream = new FileOutputStream(fileWithinMyDir);

                v.draw(canvas);
                mBitmap.compress(Bitmap.CompressFormat.PNG, 90, mFileOutStream);
                mFileOutStream.flush();
                mFileOutStream.close();
                //In case you want to delete the file
                //boolean deleted = mypath.delete();
                //Log.v("log_tag","deleted: " + mypath.toString() + deleted);
                //If you want to convert the image to string use base64 converter

                // need to update the job table with the correct signature name if DEL or PU
                if (sInType.equals("PU") || sInType.equals("DEL")) {
                    TISDBHelper oDB = new TISDBHelper(getApplicationContext(), sDBName,
                            null, iVersionVal);
                    try {
                        oDB.createDataBase();
                        oDB.openDataBase();
                        ContentValues oValues = new ContentValues();

                        String sName = yourName.getText().toString();

                        if (sInType.equals("PU")) {
                            oValues.put("pickup_signature_name",sName);
                        }
                        if (sInType.equals("DEL")) {
                            oValues.put("delivery_signature_name", sName);
                        }
                        long ldbinfo = oDB.updateRecordsInDB("jobs", "job_num='" + sInJobNum + "'", oValues);
                        oDB.close();
                    } catch (IOException ioe) {
                        throw new Error("Unable to create database");
                    } catch (Exception ex) {

                    }

                }

                Context oContext = getApplicationContext();
                oContext = getApplicationContext();
                //Update the SyncTasks table with a record stating a sig file is ready
                DateConvertClass oDateConvertClass = new DateConvertClass();
                oDateConvertClass.oContext = getApplicationContext();
                String sCurrentDateTime = oDateConvertClass.GMTTimestamp();
                SyncTasks syncTasks = new SyncTasks();
                syncTasks.oContext = getApplicationContext();
                syncTasks.sRecType = "SIG" + sInType;
                syncTasks.sRecID = current;
                syncTasks.sDateTime = sCurrentDateTime;
                syncTasks.sQueued = "1";
                syncTasks.sDateTimeQueued = "";
                syncTasks.sCompleted = "0";
                syncTasks.sDateTimeCompleted = "";
                long lRecID = syncTasks.write();
                // Make sure we send immediatly
                Intent OrderSig = new Intent(oContext, SyncIntentService.class);
                OrderSig.putExtra("RecType", "SIG" + sInType);
                OrderSig.putExtra("ID", Long.toString(lRecID));
                OrderSig.putExtra("RecID", current);
                oContext.startService(OrderSig);


                if (sInType.equals("PU") || sInType.equals("DEL")) {

                    // need to get the SIG NAMEs to the server
                    syncTasks = new SyncTasks();
                    syncTasks.oContext = getApplicationContext();
                    syncTasks.sRecType = "SIGJOB";
                    syncTasks.sRecID = sInJobNum;
                    syncTasks.sDateTime = sCurrentDateTime;
                    syncTasks.sQueued = "0"; //Set as queued so sync service will not pick it up
                    syncTasks.sDateTimeQueued = "";
                    syncTasks.sCompleted = "0";
                    syncTasks.sDateTimeCompleted = "";
                    syncTasks.write();
                }
            }
            catch(Exception e)
            {
                Log.v("log_tag", e.toString());
            }
        }

        public void clear()
        {
            path.reset();
            invalidate();
        }

        @Override
        protected void onDraw(Canvas canvas)
        {
            canvas.drawPath(path, paint);
        }

        @Override
        public boolean onTouchEvent(MotionEvent event)
        {
            float eventX = event.getX();
            float eventY = event.getY();
            miSave.setVisible(true);
            miErase.setVisible(true);

            switch (event.getAction())
            {
                case MotionEvent.ACTION_DOWN:
                    InputMethodManager imm = (InputMethodManager)getSystemService(Context.INPUT_METHOD_SERVICE);
                    imm.hideSoftInputFromWindow(yourName.getWindowToken(), 0);

                    path.moveTo(eventX, eventY);
                    lastTouchX = eventX;
                    lastTouchY = eventY;
                    return true;

                case MotionEvent.ACTION_MOVE:

                case MotionEvent.ACTION_UP:

                    resetDirtyRect(eventX, eventY);
                    int historySize = event.getHistorySize();
                    for (int i = 0; i < historySize; i++)
                    {
                        float historicalX = event.getHistoricalX(i);
                        float historicalY = event.getHistoricalY(i);
                        expandDirtyRect(historicalX, historicalY);
                        path.lineTo(historicalX, historicalY);
                    }
                    path.lineTo(eventX, eventY);
                    break;

                default:
                    debug("Ignored touch event: " + event.toString());
                    return false;
            }

            invalidate((int) (dirtyRect.left - HALF_STROKE_WIDTH),
                    (int) (dirtyRect.top - HALF_STROKE_WIDTH),
                    (int) (dirtyRect.right + HALF_STROKE_WIDTH),
                    (int) (dirtyRect.bottom + HALF_STROKE_WIDTH));

            lastTouchX = eventX;
            lastTouchY = eventY;

            return true;
        }

        private void debug(String string){
        }

        private void expandDirtyRect(float historicalX, float historicalY)
        {
            if (historicalX < dirtyRect.left)
            {
                dirtyRect.left = historicalX;
            }
            else if (historicalX > dirtyRect.right)
            {
                dirtyRect.right = historicalX;
            }

            if (historicalY < dirtyRect.top)
            {
                dirtyRect.top = historicalY;
            }
            else if (historicalY > dirtyRect.bottom)
            {
                dirtyRect.bottom = historicalY;
            }
        }

        private void resetDirtyRect(float eventX, float eventY)
        {
            dirtyRect.left = Math.min(lastTouchX, eventX);
            dirtyRect.right = Math.max(lastTouchX, eventX);
            dirtyRect.top = Math.min(lastTouchY, eventY);
            dirtyRect.bottom = Math.max(lastTouchY, eventY);
        }
    }

}
